/*
 * @description: Example applications for Impact Acquire
 * @copyright: Copyright (C) 2006 - 2018 Balluff GmbH
 * @authors: APIs and drivers development team at Balluff GmbH
 * @initial date: 2006-10-20
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next paragraph) shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

//----------------------------------------------------------------------------------------
#ifndef avihelperH
#define avihelperH avihelperH
//----------------------------------------------------------------------------------------
#include <windows.h>
#include <Vfw.h>
#include "aviexception.h"
//----------------------------------------------------------------------------------------

/*!
    \brief The codecs recognized by the \b AVIWrapper class.
*/
typedef enum
{
    codecNoCompression = 0,
    codecMorganMjpg = 1,
    codecMorganMjpg2000 = 2,
    codecIntelJpg = 3,
    codecHuffYUV = 4,
    codecDivx5 = 5,
    codec3ivx = 6,
    codecMjpg2 = 7,
    codecPicVideoWavelet = 8,
    codecPicVideoMjpg = 9,
    codecPicVideoLossLessJpg = 10,
    codecMSVideo = 11,
    codecMSRle = 12,
    codecMSH263 = 13,
    codecMSH261 = 14,
    codecIntelVidR32 = 15,
    codecIntelIndeo510 = 16,
    codecDivxMjpg4lm = 17,
    codecDivxMjpg4fm = 18,
    codecCinepack = 19,
    codecMSMpeg4 = 20,
    codecMax
} CODEC_T;

//----------------------------------------------------------------------------------------
std::string     AVIErrorToString( HRESULT error );
void            BuildTestImage( unsigned char* pData, int width, int height, int bytespp );
DWORD           CodecToFourccCode( CODEC_T codec );
//----------------------------------------------------------------------------------------

#endif // avihelperH